Index: test/Makefile.am
===================================================================
--- test/Makefile.am	(revision 1325)
+++ test/Makefile.am	(revision 1326)
@@ -32,11 +32,14 @@
 
 test_tags_handling_la_SOURCES = test_tags_handling.c
 
-TESTS = $(top_srcdir)/test/run-tests.sh
-TESTS_ENVIRONMENT = NO_MAKE=yes CUTTER="$(CUTTER)"
+TESTS = run-tests.sh
+TESTS_ENVIRONMENT = NO_MAKE=yes CUTTER="$(CUTTER)" TESTS_DIR="$(top_builddir)/test"
 
 echo-cutter:
 	@echo $(CUTTER)
 
+echo-tests-dir:
+	@echo $(top_builddir)/test
+
 endif
 
Index: test/run-tests.sh
===================================================================
--- test/run-tests.sh	(revision 1325)
+++ test/run-tests.sh	(revision 1326)
@@ -5,6 +5,11 @@
 
 if test -z "$NO_MAKE"; then
     make -C $top_dir > /dev/null || exit 1
+  TESTS_DIR=$BASE_DIR
+else
+  if test -z "$TESTS_DIR"; then
+    TESTS_DIR="`make -s -C $BASE_DIR echo-tests-dir`"
+  fi
 fi
 
 if test -z "$CUTTER"; then
@@ -21,5 +26,5 @@
   exit 1
 }
 
-$CUTTER -s $BASE_DIR "$@" $BASE_DIR
+$CUTTER -s $BASE_DIR "$@" $TESTS_DIR
 
